//+------------------------------------------------------------------+
//|                                       cm_ .mq4 |
//|                                Copyright 2016, cmillion@narod.ru |
//|                                               http://cmillion.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, cmillion@narod.ru"
#property link      "http://cmillion.ru"
//+------------------------------------------------------------------+
color Color=clrRed;
int slippage = 30;
string val;
//+------------------------------------------------------------------+
int start()
{
   ButtonCreate(0," ",0,300,10,200,20," ","Arial",10,clrBlack,clrLime,clrLightGray,clrNONE,false);
   ButtonCreate(0," ",0,300,30,200,20," ","Arial",10,clrBlack,clrLime,clrLightGray,clrNONE,false);
   ButtonCreate(0," ",0,300,50,200,20," ","Arial",10,clrBlack,clrLime,clrLightGray,clrNONE,false);
   ButtonCreate(0," ",0,300,70,200,20," ","Arial",10,clrBlack,clrLime,clrLightGray,clrNONE,false);
   ButtonCreate(0," BUY",0,300,90,200,20," BUY","Arial",10,clrBlack,clrLime,clrLightGray,clrNONE,false);
   ButtonCreate(0," SELL",0,300,110,200,20," SELL","Arial",10,clrBlack,clrLime,clrLightGray,clrNONE,false);
   ButtonCreate(0," ",0,300,130,200,20," ","Arial",10,clrBlack,clrLime,clrLightGray,clrNONE,false);
   string name="";
   double OOP,PriceMax,PriceMin;
   double WPMax=WindowPriceMax();
   double WPMin=WindowPriceMin();
   if (ObjectFind(name)==-1)
   {
      for (int i=0; i<OrdersTotal(); i++)
      {    
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         { 
            if (OrderSymbol()==Symbol())
            { 
               OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
               if (PriceMax<OOP) PriceMax=OOP;
               if (PriceMin>OOP || PriceMin==0) PriceMin=OOP;
            }
         }
      } 
      if (PriceMax==0) PriceMax = WPMax-(WPMax-WPMin)/10;
      if (PriceMin==0) PriceMin = WPMin+(WPMax-WPMin)/10;
      ObjectCreate(name, OBJ_TREND, 0, 0,0, 0,0);
      ObjectSet   (name, OBJPROP_COLOR, Color);
      ObjectSet   (name, OBJPROP_TIME1 ,Time[0]);
      ObjectSet   (name, OBJPROP_PRICE1,PriceMax);
      ObjectSet   (name, OBJPROP_TIME2 ,Time[0]);
      ObjectSet   (name, OBJPROP_PRICE2,PriceMin);
      ObjectSet   (name, OBJPROP_WIDTH,5);
      ObjectSet   (name, OBJPROP_RAY,false);
   }
   val = StringConcatenate(" ",AccountCurrency());
   while (ObjectFind(name)!=-1 && !IsStopped())
   {
      PriceMax = ObjectGet(name,OBJPROP_PRICE1);
      PriceMin = ObjectGet(name,OBJPROP_PRICE2);
      if (PriceMax<PriceMin) {PriceMax=PriceMin; PriceMin = ObjectGet(name,OBJPROP_PRICE1);}
      string txt=StringConcatenate("      ",DoubleToStr(PriceMin,Digits),"  ",DoubleToStr(PriceMax,Digits));
      //---
      int b=0,s=0,bs=0,ss=0,bl=0,sl=0,OT,Ticket;
      double ProfitS=0,ProfitB=0,Profit;
      for (i=OrdersTotal()-1; i>=0; i--)
      {    
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         { 
            if (OrderSymbol()==Symbol())
            { 
               OOP = NormalizeDouble(OrderOpenPrice(),Digits);
               OT  = OrderType();
               Ticket=OrderTicket();
               Profit = OrderProfit()+OrderSwap()+OrderCommission();
               if (PriceMax>=OOP && PriceMin<=OOP)
               {
                  if(OT==OP_BUY)
                  {
                     if (ObjectGetInteger(0," ",OBJPROP_STATE) || ObjectGetInteger(0," BUY",OBJPROP_STATE)) 
                     {
                        if (OrderClose(Ticket,OrderLots(),NormalizeDouble(Bid,Digits),slippage,Blue))
                           Comment(" BUY  ",Ticket,"  ",DoubleToStr(Profit,2),val);
                        else 
                        {
                           Comment(" ",GetLastError(),"  BUY  ",Ticket);
                        }
                     }
                     else 
                     {
                        b++;
                        ProfitB+=Profit;
                     }
                  }
                  if(OT==OP_SELL)
                  {
                     if (ObjectGetInteger(0," ",OBJPROP_STATE) || ObjectGetInteger(0," SELL",OBJPROP_STATE)) 
                     {
                        if (OrderClose(Ticket,OrderLots(),NormalizeDouble(Ask,Digits),slippage,Red))
                           Comment(" SELL  ",Ticket,"  ",DoubleToStr(Profit,2),val);
                        else 
                        {
                           Comment(" ",GetLastError(),"  SELL  ",Ticket);
                        }
                     }
                     else 
                     {
                        s++;
                        ProfitS+=Profit;
                     }
                  }
                  if(OT==OP_BUYSTOP)
                  {
                     if (ObjectGetInteger(0," ",OBJPROP_STATE) || ObjectGetInteger(0," ",OBJPROP_STATE)) 
                     {
                        if (OrderDelete(Ticket))
                           Comment(" BUYSTOP  ",Ticket);
                        else 
                           Comment(" ",GetLastError(),"  BUYSTOP  ",Ticket);
                     }
                     else bs++;
                  }
                  if(OT==OP_SELLSTOP)
                  {
                     if (ObjectGetInteger(0," ",OBJPROP_STATE) || ObjectGetInteger(0," ",OBJPROP_STATE)) 
                     {
                        if (OrderDelete(Ticket))
                           Comment(" SELLSTOP  ",Ticket);
                        else 
                           Comment(" ",GetLastError(),"  SELLSTOP  ",Ticket);
                     }
                     else ss++;
                  }
                  if(OT==OP_BUYLIMIT)
                  {
                     if (ObjectGetInteger(0," ",OBJPROP_STATE) || ObjectGetInteger(0," ",OBJPROP_STATE)) 
                     {
                        if (OrderDelete(Ticket))
                           Comment(" BUYLIMIT  ",Ticket);
                        else 
                           Comment(" ",GetLastError(),"  BUYLIMIT  ",Ticket);
                     }
                     else bl++;
                  }
                  if(OT==OP_SELLLIMIT)
                  {
                     if (ObjectGetInteger(0," ",OBJPROP_STATE) || ObjectGetInteger(0," ",OBJPROP_STATE)) 
                     {
                        if (OrderDelete(Ticket))
                           Comment(" SELLLIMIT  ",Ticket);
                        else 
                           Comment(" ",GetLastError(),"  SELLLIMIT  ",Ticket);
                     }
                     else sl++;
                  }
               }
            }
         }
      }
      //---
      txt = StringConcatenate(txt,"\n",b," ",DoubleToStr(ProfitB,2),val," buy\n",s," ",DoubleToStr(ProfitS,2),val," sell\n",bs," buyStop\n",ss," sellStop\n",bl," buyLimit\n",sl," sellLimit"); 
      Comment(txt);
      if (ObjectGetInteger(0," ",OBJPROP_STATE)) break;
      Sleep(500);
      RefreshRates();
   }
   ObjectDelete(name);
   ObjectDelete(" ");
   ObjectDelete(" ");
   ObjectDelete(" ");
   ObjectDelete(" ");
   ObjectDelete(" BUY");
   ObjectDelete(" SELL");
   ObjectDelete(" ");
   Comment("   \n     http://cmillion.ru");
   return(0);
}
//+------------------------------------------------------------------+
color Color(double P)
{
   if (P>0) return(Lime);
   if (P<0) return(Red);
   return(Color);//Gray
}
//------------------------------------------------------------------
bool ButtonCreate(const long              chart_ID=0,               // ID 
                  const string            name="Button",            //  
                  const int               sub_window=0,             //  
                  const long               x=0,                      //    X
                  const long               y=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const string            text="Button",            // 
                  const string            font="Arial",             // 
                  const int               font_size=10,             //  
                  const color             clr=clrRed,               //  
                  const color             clrON=clrLime,            //  
                  const color             clrOFF=clrBlack,          //  
                  const color             border_clr=clrNONE,       //  
                  const bool              state=false)              // /
  {
   if (ObjectFind(chart_ID,name)==-1)
   {
      ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0);
      ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
      ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,ANCHOR_CENTER);
      ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
      ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
      ObjectSetInteger(chart_ID,name,OBJPROP_BACK,0);
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,0);
      ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,1);
      ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,1);
      ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
   color back_clr;
   if (ObjectGetInteger(chart_ID,name,OBJPROP_STATE)) back_clr=clrON; else back_clr=clrOFF;
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   return(true);
}
//--------------------------------------------------------------------
